<?php
namespace Controleur;
use App\Attributes\Route;
use App\Container;
use App\Router\Request\IRequest;
use App\Router\Responce\Response;
use Shared\Validation;
// use App\Enums\HttpMethod;

class CoachControleur extends BaseController
{
    private $DataManager;
    public function __construct(Container $container)
    {
        global $twig; 
        session_start();
        $this->DataManager = $container->get('DBDATAMANAGER');
        
    }

    #[Route(path: '/', name: 'test', methods:['GET'])] // 8
    public function index(): Response{
        return new Response( $this->Reinit());
       
    }
    #[Route(path: '/addAthl', name: 'test', methods:['Post'])] // 8
    public function addAthlthe(IRequest $req,string $userName){
        if(Validation::val_string($userName)){
            $resp = $this->$DataManager->coachManager->addAthlthe($userName);
            if($resp){
                return new Response($container->get('twig')->render('listAthlet.html.twig',$this->$DataManager->coachManager->getCurrentUser()->listAthlete));
            }

        }
    }

    public function Reinit()
    {
        global $twig;

        $dVue = [
            'nom' => '',
            'age' => 0,
            'email'=> '',
        ];
        return $twig->render('vuephp1.html.twig', [
            'dVue' => $dVue
        ]);
    }
    #[Route(path: '/hello', methods:['GET'], name: 'hello')]
    public function hello(): Response{
        return new Response('Hello');
    }

    #[Route(path: '/hi', methods:['GET'],name: 'hi')]
    public function hi(string $name,IRequest $req): Response{
        return new Response($name.$req->getMethod());
    }

    public function ValidationFormulaire(array $dVueEreur)
    {
        global $twig; // nécessaire pour utiliser variables globales

        //si exception, ca remonte !!!
        $nom = $_POST['txtNom']; // txtNom = nom du champ texte dans le formulaire
        $age = $_POST['txtAge'];
        $email = $_POST['email'];

        \config\Validation::val_form($nom, $age,$email, $dVueEreur);

        $model = new \modeles\Simplemodel();
        $data  = $model->get_data();

        $dVue = [
            'nom'  => $nom,
            'email'  => $email,
            'age'  => $age,
            'data' => $data,
        ];

        echo $twig->render('vuephp1.html.twig', ['dVue' => $dVue, 'dVueEreur' => $dVueEreur]);
    }
}//fin class



