<?php
use App\Container;
use App\Router\Request\IRequest;
use App\Router\Router;
use Controllers\IArgumentResolver;
use Shared\Exception\NotImplementedException;
// App etre sur que la persone a le droit defaire
class FrontController {
    private $router;

    private $container;

    public function __construct(Router $router, Container $container) {
        $this->router = $router;
        $this->container = $container;

    }

    public function dispatch(IRequest $request) {
        try {
            $match = $this->router->match($request);

            if (!is_null($match)) {
                $controller = $this->getController($match['target']);
                $request->addToBody($match['params']);
                
                
                if (!is_callable($controller)){
                    // body to key values maybe is better
                    // $request  = array_reduce($params, function ($request, $key) use ($params) {
                    //     return $request->withAttribute($key, $params[$key]);
                    //    }, $request);
                    // if (is_callable($action)) {
                    //     return $action();
                    // }
                    
                    // if (is_array($action)) {
                    //     [$className, $method] = $action;
            
                    //     if (class_exists($className) && method_exists($className, $method)) {
                    //         $class = new $className();
                    //         return call_user_func_array([$class, $method], []);
                    //     }
                    // }
                    throw new NotImplementedException('Handle when route targer is not a callable not handle');  
                }
                $argumentResolver = $this->container->get(IArgumentResolver::class);
                $arguments = $argumentResolver->getArguments($request, $controller);
                $response = call_user_func_array($controller, $arguments);
                // should handle responce proprely like if its a HTML, STING, JSON,....
                return $response;
            } else {
                return $this->handleError(404, "Page not found");
            }
        } catch (NotFoundHttpException $e) {
            return $this->handleError(404, $e->getMessage());
        } catch (\Exception $e) {
            return $this->handleError(500, "Internal Server Error: " . $e->getMessage());
        }
    }

    // public function dispatch(IRequest $request) {
    //     // si sa match sa me retourn une route
    //     $match = $this->router->match($request);
    //     // si j'ai bien récupe une route
    //     if (!is_null($match)) {
    //         // $controllerName = $match['controller'];
    //         // $callable = $match['target'];
    //         // $request->addAttributes($match['params']);



    //         // Utilisez l'injection de dépendances pour avoir le contrôleur - en gros par rapport à la chaine de carractère la on demmande est ce que on peut avoir une instantce d'un objet(la callable)
    //         // je résous les param qui sont dans la request pa rapport à l'appel de fonction(le callable)
    //         $params = $match->getParams();
    //         $request  = array_reduce($params, function ($request, $key) use ($params) {
    //          return $request->withAttribute($key, $params[$key]);
    //         }, $request);

    //         // on va vérifié si dans la request j'ai les finfo nécéssaire pour le callable(controller)
    //         $arguments = $this->argumentResolver->getArguments($request, $controller);

    //         $this->dispatcher->dispatch(new ArgumentEvent($request, $controller, $arguments), 'kernel.arguments');

    //         $response = call_user_func_array($controller, $arguments);
    //         // if (is_callable($route->getCallable())){
    //         //     call_user_func_array($controller, $request);
    //         // }
    //         // can i a dd a logic to have defined route like new Route('', function()) => so without class
    //         // so il i can check 
    //         // public function resolve(string $requestUri, string $requestMethod): mixed
    //         // {
    //         //     $path = explode('?', $requestUri)[0];
    //         //     $action = $this->routes[$requestMethod][$path] ?? null;
        
    //         //     if (is_callable($action)) {
    //         //         return $action();
    //         //     }
                
    //         //     if (is_array($action)) {
    //         //         [$className, $method] = $action;
        
    //         //         if (class_exists($className) && method_exists($className, $method)) {
    //         //             $class = new $className();
    //         //             return call_user_func_array([$class, $method], []);
    //         //         }
    //         //     }
        
    //         //     throw new RouteNotFoundException();
    //         // }

    //         if ($controller && is_callable(array($controller, $route->getParams()))) {
    //             // Appeler l'action correspondante
    //             // $controller->$actionName();
    //             // should call DI container or Arguments Resolver ($arguments = $this->argumentResolver->getArguments($request, $controller);)
    //             // $response = call_user_func_array($controller, $arguments);
    //             // to get correct argument
    //             // ORR like graphicsArt set it un Request
    //             // So je mets dans la request en tant que attribu ce que à besoin ma function et du coup dans le controller je fait un $request->getAttribute('name')
    //             // a peu près comme je fais en js  const { email, password } = req.body;
    //             // ou j'utilise un Argument resolver qui va le le faire
    //             call_user_func_array($controller, $request);
    //         } else {
    //             // Gérer l'erreur, le contrôleur n'existe pas
    //             $this->handleError();
    //         }
    //     } else {
    //         // Gérer l'erreur, aucune route correspondante
    //         $this->handleError();
    //     }
    // }

    private function getController($controllerName) {
        // Utilisez un conteneur d'injection de dépendances pour créer le contrôleur
        return $this->container->get($controllerName);
    }

  
    private function handleError($statusCode, $message) {// composant twig
        // http_response_code($statusCode);
        $response = new Response($statusCode, $message);
        echo $message;
         // status,..., body
        // return new Responce(404,[notfond],erreur.twig)
    }

}

?>
<!-- 
Point d'entrée unique : Le front controller est le point d'entrée unique de toutes les requêtes HTTP entrantes dans une application Symfony. Toutes les requêtes sont dirigées vers ce contrôleur, qui est généralement un fichier PHP, tel que public/index.php.

Initialisation : Le front controller initialise l'application en chargeant les dépendances, en configurant l'environnement, en définissant les paramètres globaux, et en préparant l'infrastructure de base nécessaire pour gérer les requêtes HTTP.

Gestion de la requête : Une fois qu'une requête HTTP arrive, le front controller crée un objet Request à partir de cette requête entrante. Il s'occupe également de la gestion de la session, de la gestion des cookies, et de l'analyse des en-têtes HTTP.

Routage vers le contrôleur : Le front controller interagit avec le router pour déterminer quel contrôleur doit être utilisé pour traiter la requête. Il envoie la requête au router pour faire correspondre l'URL demandée à une route et obtenir des informations sur le contrôleur et l'action associés.

Résolution du contrôleur : Une fois que le router a identifié le contrôleur et l'action à appeler, le front controller résout le contrôleur en créant une instance de l'objet contrôleur approprié. Il extrait également l'action à appeler.

Exécution de l'action : Le front controller appelle l'action du contrôleur avec les paramètres nécessaires, généralement en passant l'objet Request. L'action effectue le traitement spécifique à la page, tel que la récupération de données, la manipulation des données, etc.

Génération de la réponse : Après avoir exécuté l'action, le contrôleur génère une réponse HTTP sous la forme d'un objet Response. Cette réponse peut contenir des données à afficher dans le navigateur du client.

Envoi de la réponse : Le front controller envoie finalement la réponse HTTP générée par le contrôleur au client, qui l'affiche dans le navigateur -->


<!-- c'est App -->