<?php
namespace App\Router;

// // map users details page using controller#action string
// $router->map( 'GET', '/users/[i:id]/', 'UserController#showDetails' );

// // map contact form handler using function name string
// $router->map( 'POST', '/contact/', 'handleContactForm' );
class Route
{
    private string $name;

	private string $path;

	private string $method; // callable|array
    
    private $callable;

    public function __construct(string $path, callable $callable, array $params = null,string $name = null)
    {
		$this->path = $path;
        $this->callable = $callable;
        $this->name = $name;
    }


    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(?string $name): void
    {
        $this->name = $name;
    }

    public function getCallable()
    {
        return $this->callable;
    }

	public function getPath(): string
	{
		return $this->path;
	}

    public function setCallable(callable $callable)
    {
        $this->callable = $callable;
    }
}
