<?php

namespace App\Attributes;
use App\Enums\HttpMethod;

#[\Attribute(\Attribute::TARGET_METHOD | \Attribute::TARGET_CLASS)]
class Route
{

	public function __construct(
        private string|array $path = null,
        private ?string $name = null,
        private array|HttpMethod $methods = HttpMethod::Get,
    )
	{
     
	}

	public function getPath(): array| string{
		return $this->path;
	}

    public function getName(): ?string{
        return $this->name;
    }
    public function getMethods(): array | HttpMethod
    {
        return $this->methods;
    }

	
}

