<?php
namespace Database;

abstract class DbContext {
    protected $databaseConnection;

    public function __construct() {
        $this->onConfiguring();
        $this->onModelCreating();
    }

    protected abstract function onConfiguring();
    protected abstract function onModelCreating();

    protected function isConfigured() {
        return $this->databaseConnection !== null;
    }
    // getInstantce
    protected function seedDatabase($sqlFilePath) {
        if (!$this->isConfigured()) {
            if (file_exists($sqlFilePath)) {
                try {
                    $sql = file_get_contents($sqlFilePath);
                    $this->databaseConnection->exec($sql);
                    echo "Database seeded successfully.";
                } catch (\PDOException $e) {
                    echo "Error seeding database: " . $e->getMessage();
                }
            } else {
                echo "SQL file not found: $sqlFilePath";
            }
        }
       
    }
}
