<?php
namespace Database;
use Database\Gateway\UserGateway;

class HeartDbContext extends DbContext {
    public $userGateWay;
    private $seed = true;
    // ... autres gateways pour chaque entité

    public function __construct() {
        // Initialisation de chaque gateway avec la connexion à la base de données
        $databaseConnection = DatabaseConnection::getInstance("");
        $this->userGateWay = new UserGateway($databaseConnection);
    }

    public function onConfiguring() {
        if (!$this->isConfigured()) {
            echo "!IsConfigured...\n";
            try {
                $options = $this->getConnectionOptions();
                $this->databaseConnection = DatabaseConnection::getInstance($options['dsn'], $options['username'], $options['password']);
                echo 'Successfully connected to the database';
            } catch (PDOException $e) {
                echo 'Error connecting to the database: ' . $e->getMessage();
            }
        }

      
    }
    protected function getConnectionOptions(): array {
        // 'dbname' => 'mydb',
        // 'user' => 'user',
        // 'password' => 'secret',
        // 'host' => 'localhost',
        // 'driver' => 'pdo_mysql',
        return [
            'dsn' => 'mysql:host=localhost;dbname=your_database',
            'username' => 'your_username',
            'password' => 'your_password'
        ];
    }


    public function onModelCreating() {
        if (!$this->isConfigured() && $this->seed) {
            $this->seedDatabase(__DIR__ . '/../../../config/heart.sql');
        }
    }
}
